Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type CollectionTable

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface CollectionTable

Specifies the table that is used for the mapping of collections of basic or embeddable types. Applied to the collection-valued field or property.

By default, the columns of the collection table that correspond to the embeddable class or basic type are derived from the attributes of the embeddable class or from the basic type according to the default values of the `Column` annotation. In the case of a basic type, the column name is derived from the name of the collection-valued field or property. In the case of an embeddable class, the column names are derived from the field or property names of the embeddable class.

- To override the default properties of the column used for a basic type, the `Column` annotation is used on the collection-valued attribute in addition to the `ElementCollection` annotation.
- To override these defaults for an embeddable class, the `AttributeOverride` and/or `AttributeOverrides` annotations can be used in addition to the `ElementCollection` annotation. If the embeddable class contains references to other entities, the default values for the columns corresponding to those references may be overridden by means of the `AssociationOverride` and/or `AssociationOverrides` annotations.

If the `CollectionTable` annotation is missing, the default values of the `CollectionTable` annotation elements apply.

        Example:

        @Embeddable public class Address {
           protected String street;
           protected String city;
           protected String state;
           ...
         }

        @Entity public class Person {
           @Id protected String ssn;
           protected String name;
           protected Address home;
           ...
           @ElementCollection  // use default table (PERSON_NICKNAMES)
           @Column(name="name", length=50)
           protected Set<String> nickNames = new HashSet();
           ...
        }

        @Entity public class WealthyPerson extends Person {
           @ElementCollection
           @CollectionTable(name="HOMES") // use default join column name
           @AttributeOverrides({
              @AttributeOverride(name="street",
                                 column=@Column(name="HOME_STREET")),
              @AttributeOverride(name="city",
                                 column=@Column(name="HOME_CITY")),
              @AttributeOverride(name="state",
                                 column=@Column(name="HOME_STATE"))
            })
           protected Set<Address> vacationHomes = new HashSet();
           ...
        }

Since:
  Java Persistence 2.0
See Also:
  `ElementCollection`, `AttributeOverride`, `AssociationOverride`, `Column`

Optional Element Summary
`java.lang.String` | `catalog` (Optional) The catalog of the table.
`JoinColumn[]` | `joinColumns` (Optional) The foreign key columns of the collection table which reference the primary table of the entity.
`java.lang.String` | `name` (Optional) The name of the collection table.
`java.lang.String` | `schema` (Optional) The schema of the table.
`UniqueConstraint[]` | `uniqueConstraints` (Optional) Unique constraints that are to be placed on the table.

### name

    public abstract java.lang.String name

  (Optional) The name of the collection table. If not specified, it defaults to the concatenation of the name of the containing entity and the name of the collection attribute, separated by an underscore.

  Default:
    ""

### catalog

    public abstract java.lang.String catalog

  (Optional) The catalog of the table. If not specified, the default catalog is used.

  Default:
    ""

### schema

    public abstract java.lang.String schema

  (Optional) The schema of the table. If not specified, the default schema for the user is used.

  Default:
    ""

### joinColumns

    public abstract JoinColumn[] joinColumns

  (Optional) The foreign key columns of the collection table which reference the primary table of the entity. The default only applies if a single join column is used. The default is the same as for `JoinColumn` (i.e., the concatenation of the following: the name of the entity; "_"; the name of the referenced primary key column.) However, if there is more than one join column, a `JoinColumn` annotation must be specified for each join column using the `JoinColumns` annotation. In this case, both the `name` and the `referencedColumnName` elements must be specified in each such `JoinColumn` annotation.

  Default:
    {}

### uniqueConstraints

    public abstract UniqueConstraint[] uniqueConstraints

  (Optional) Unique constraints that are to be placed on the table. These are only used if table generation is in effect.

  Default:
    {}

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT